package com.galaxis.manatee.Test.zzx;

import com.galaxis.manatee.entity.chuanyun.data.object.Handbook;
import com.galaxis.manatee.entity.chuanyun.data.object.MyExcelData;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.FileInputStream;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

@Slf4j
@SpringBootTest
/**
 * 读取excel文件
 */
public class ProjectTest2 {
    public static void main(String[] args) {
        List<List<Object>> excel1 = getExcel("C:\\Users\\mayn\\Desktop\\分权手册2022_09_20_16_31_58.xlsx");
        List<List<Object>> excel2 = getExcel("C:\\Users\\mayn\\Desktop\\凯捷--2022年度分级授权手册20220920更新了花名册.xls");

        //最新的h2分权手册
        List<MyExcelData> excelDataList = new ArrayList<>();
        for (int j = 0; j < excel2.size(); j++) {
            List<Object> objects2 = excel2.get(j);
            // System.err.println(objects2);
            if (j > 1) {
                //System.err.println(objects2);
                String objects2Sub = objects2.toString().substring(1, objects2.toString().length() - 1);
                String[] splitArr2 = objects2Sub.split(",");
                // splitArr数组:7-一级领导,8-二级领导,9-三级领导,10-总经理,11-集团分管领导
                MyExcelData myExcelData = new MyExcelData();
                myExcelData.setName(splitArr2[1]);
                myExcelData.setFirstName(splitArr2[7]);
                myExcelData.setSecondName(splitArr2[8]);
                myExcelData.setThirdName(splitArr2[9]);
                myExcelData.setManager(splitArr2[10]);
                myExcelData.setGroupChargeLeader(splitArr2[11]);
                excelDataList.add(myExcelData);
            }
        }

        // 集团所有人的信息
        List<Handbook> handbookList = new ArrayList<>();
        for (int i = 0; i < excel1.size(); i++) {
            List<Object> objects1 = excel1.get(i);
            if (i > 1) {
                // System.err.println(objects.toString());
                String objects1Sub = objects1.toString().substring(1, objects1.toString().length() - 1);
                String[] splitArr1 = objects1Sub.split(",");
                // System.err.println("姓名：" + splitArr1[1] + "，一级领导：" + splitArr1[9]);
                // splitArr数组:9-一级领导,10-二级领导,11-三级领导,13-分公司总经理,14-集团分管领导
                Handbook handbook = new Handbook();
                handbook.setObjectId(splitArr1[0]);
                handbook.setName(splitArr1[1]);
                handbook.setCreatedBy(splitArr1[2]);
                handbook.setOwnerId(splitArr1[3]);
                handbook.setOwnerDeptId(splitArr1[4]);
                handbook.setCreatedTime(splitArr1[5]);
                handbook.setModifiedTime(splitArr1[6]);
                handbook.setF0000001(splitArr1[7]);
                handbook.setF0000002(splitArr1[8]);
                handbook.setF0000003(splitArr1[9]);
                handbook.setF0000004(splitArr1[10]);
                handbook.setF0000005(splitArr1[11]);
                handbook.setF0000011(splitArr1[12]);
                handbook.setF0000006(splitArr1[13]);
                handbook.setF0000007(splitArr1[14]);
                handbook.setF0000009(splitArr1[15]);
                handbook.setF0000008(splitArr1[16]);
                handbook.setF0000010(splitArr1[17]);
                handbook.setF0000012(splitArr1[18]);

                for (int k = 0; k < excelDataList.size(); k++) {
                    MyExcelData myExcelData = excelDataList.get(k);
                    //System.err.println("handbook.getName()：" + handbook.getName() + "，myExcelData.getName()：" + myExcelData.getName());
                    if (handbook.getName().equals(myExcelData.getName())) {
                        handbook.setF0000003(myExcelData.getFirstName());
                        handbook.setF0000004(myExcelData.getSecondName());
                        handbook.setF0000005(myExcelData.getThirdName());
                        handbook.setF0000006(myExcelData.getManager());
                        handbook.setF0000007(myExcelData.getGroupChargeLeader());
                    }
                }

                handbookList.add(handbook);
            }
        }

         // System.err.println(handbookList.toString());
          System.err.println(handbookList.get(607));  //陈中彬
    }

    public static List<List<Object>> getExcel(String filePath) {
        Workbook wb = null;
        Sheet sheet = null;
        Row row = null;

        // String filePath1 = "C:\\Users\\86186\\Desktop\\分权手册2022_09_20_16_31_58.xlsx";
        wb = readExcel(filePath);

        List<List<List<Object>>> list = new ArrayList<>();
        if (wb != null) {
            try {
                // 循环页签
                for (int sheetNum = 0; sheetNum < wb.getNumberOfSheets(); sheetNum++) {
                    // 指定页签的值
                    sheet = wb.getSheetAt(sheetNum);
                    // 定义存放一个页签中所有数据的List
                    List<List<Object>> sheetList = new ArrayList<>();
                    // 循环行
                    for (int rowNum = 0; rowNum <= sheet.getLastRowNum(); rowNum++) {
                        // 指定行的值
                        row = sheet.getRow(rowNum);
                        // 定义存放一行数据的List
                        List<Object> rowList = new ArrayList<>();
                        // 循环列
                        if (row != null) {
                            for (int cellNum = 0; cellNum < row.getLastCellNum(); cellNum++) {
                                Cell cell = sheet.getRow(rowNum).getCell(cellNum);
                                rowList.add(getStringCellValue(cell));
                            }
                        }
                        sheetList.add(rowList);
                    }
                    list.add(sheetList);
                }
                // System.err.println(list.get(0).size());
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return list.get(0);
    }

    //判断文件格式
    public static Workbook readExcel(String filePath) {
        if (filePath == null) {
            return null;
        }
        String extString = filePath.substring(filePath.lastIndexOf("."));
        try {
            InputStream is = new FileInputStream(filePath);
            if (".xls".equals(extString)) {
                return new HSSFWorkbook(is);
            } else if (".xlsx".equals(extString)) {
                return new XSSFWorkbook(is);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static String getStringCellValue(Cell cell) {
        String cellvalue = "";
        if (cell == null) {
            return "";
        }
        switch (cell.getCellType()) {
            case Cell.CELL_TYPE_STRING:
                cellvalue = cell.getStringCellValue();
                break;
            case Cell.CELL_TYPE_NUMERIC:
                if (DateUtil.isCellDateFormatted(cell)) {
                    SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                    Date date = cell.getDateCellValue();
                    cellvalue = sdf.format(date);
                } else {
                    cellvalue = String.valueOf(cell.getNumericCellValue());
                }
                break;
            case Cell.CELL_TYPE_BOOLEAN:
                cellvalue = String.valueOf(cell.getBooleanCellValue());
                break;
            case Cell.CELL_TYPE_BLANK:
                cellvalue = "";
                break;
            default:
                cellvalue = "";
                break;
        }
        if (cellvalue == "") {
            return "";
        }
        return cellvalue;
    }
}